import { ATN } from "antlr4ts/atn/ATN";
import { CharStream } from "antlr4ts/CharStream";
import { Lexer } from "antlr4ts/Lexer";
import { Vocabulary } from "antlr4ts/Vocabulary";
export declare class RelativeDateFormatLexer extends Lexer {
    static readonly NOW = 1;
    static readonly SECONDS = 2;
    static readonly MINUTES = 3;
    static readonly HOURS = 4;
    static readonly DAYS = 5;
    static readonly WEEKS = 6;
    static readonly MONTHS = 7;
    static readonly QUARTERS = 8;
    static readonly YEARS = 9;
    static readonly RANGE = 10;
    static readonly TRAIL = 11;
    static readonly PERIOD = 12;
    static readonly OP_MIN = 13;
    static readonly OP_ADD = 14;
    static readonly NUMBER = 15;
    static readonly SEPERATOR = 16;
    static readonly WS = 17;
    static readonly channelNames: string[];
    static readonly modeNames: string[];
    static readonly ruleNames: string[];
    private static readonly _LITERAL_NAMES;
    private static readonly _SYMBOLIC_NAMES;
    static readonly VOCABULARY: Vocabulary;
    readonly vocabulary: Vocabulary;
    constructor(input: CharStream);
    readonly grammarFileName: string;
    readonly ruleNames: string[];
    readonly serializedATN: string;
    readonly channelNames: string[];
    readonly modeNames: string[];
    static readonly _serializedATN: string;
    static __ATN: ATN;
    static readonly _ATN: ATN;
}
