"use strict";
// Generated from ./grammar/v1/RelativeDateFormat.g4 by ANTLR 4.7.3-SNAPSHOT
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ATNDeserializer_1 = require("antlr4ts/atn/ATNDeserializer");
const Lexer_1 = require("antlr4ts/Lexer");
const LexerATNSimulator_1 = require("antlr4ts/atn/LexerATNSimulator");
const VocabularyImpl_1 = require("antlr4ts/VocabularyImpl");
const Utils = __importStar(require("antlr4ts/misc/Utils"));
class RelativeDateFormatLexer extends Lexer_1.Lexer {
    // tslint:enable:no-trailing-whitespace
    constructor(input) {
        super(input);
        this._interp = new LexerATNSimulator_1.LexerATNSimulator(RelativeDateFormatLexer._ATN, this);
    }
    // @Override
    // @NotNull
    get vocabulary() {
        return RelativeDateFormatLexer.VOCABULARY;
    }
    // @Override
    get grammarFileName() { return "RelativeDateFormat.g4"; }
    // @Override
    get ruleNames() { return RelativeDateFormatLexer.ruleNames; }
    // @Override
    get serializedATN() { return RelativeDateFormatLexer._serializedATN; }
    // @Override
    get channelNames() { return RelativeDateFormatLexer.channelNames; }
    // @Override
    get modeNames() { return RelativeDateFormatLexer.modeNames; }
    static get _ATN() {
        if (!RelativeDateFormatLexer.__ATN) {
            RelativeDateFormatLexer.__ATN = new ATNDeserializer_1.ATNDeserializer().deserialize(Utils.toCharArray(RelativeDateFormatLexer._serializedATN));
        }
        return RelativeDateFormatLexer.__ATN;
    }
}
RelativeDateFormatLexer.NOW = 1;
RelativeDateFormatLexer.SECONDS = 2;
RelativeDateFormatLexer.MINUTES = 3;
RelativeDateFormatLexer.HOURS = 4;
RelativeDateFormatLexer.DAYS = 5;
RelativeDateFormatLexer.WEEKS = 6;
RelativeDateFormatLexer.MONTHS = 7;
RelativeDateFormatLexer.QUARTERS = 8;
RelativeDateFormatLexer.YEARS = 9;
RelativeDateFormatLexer.RANGE = 10;
RelativeDateFormatLexer.TRAIL = 11;
RelativeDateFormatLexer.PERIOD = 12;
RelativeDateFormatLexer.OP_MIN = 13;
RelativeDateFormatLexer.OP_ADD = 14;
RelativeDateFormatLexer.NUMBER = 15;
RelativeDateFormatLexer.SEPERATOR = 16;
RelativeDateFormatLexer.WS = 17;
// tslint:disable:no-trailing-whitespace
RelativeDateFormatLexer.channelNames = [
    "DEFAULT_TOKEN_CHANNEL", "HIDDEN",
];
// tslint:disable:no-trailing-whitespace
RelativeDateFormatLexer.modeNames = [
    "DEFAULT_MODE",
];
RelativeDateFormatLexer.ruleNames = [
    "NOW", "SECONDS", "MINUTES", "HOURS", "DAYS", "WEEKS", "MONTHS", "QUARTERS",
    "YEARS", "RANGE", "TRAIL", "PERIOD", "OP_MIN", "OP_ADD", "NUMBER", "SEPERATOR",
    "WS",
];
RelativeDateFormatLexer._LITERAL_NAMES = [
    undefined, "'now'", "'s'", "'m'", "'h'", "'d'", "'w'", "'M'", "'Q'", "'Y'",
    "'range'", "'trail'", "'period'", "'-'", "'+'", undefined, "'$'",
];
RelativeDateFormatLexer._SYMBOLIC_NAMES = [
    undefined, "NOW", "SECONDS", "MINUTES", "HOURS", "DAYS", "WEEKS", "MONTHS",
    "QUARTERS", "YEARS", "RANGE", "TRAIL", "PERIOD", "OP_MIN", "OP_ADD", "NUMBER",
    "SEPERATOR", "WS",
];
RelativeDateFormatLexer.VOCABULARY = new VocabularyImpl_1.VocabularyImpl(RelativeDateFormatLexer._LITERAL_NAMES, RelativeDateFormatLexer._SYMBOLIC_NAMES, []);
RelativeDateFormatLexer._serializedATN = "\x03\uC91D\uCABA\u058D\uAFBA\u4F53\u0607\uEA8B\uC241\x02\x13^\b\x01\x04" +
    "\x02\t\x02\x04\x03\t\x03\x04\x04\t\x04\x04\x05\t\x05\x04\x06\t\x06\x04" +
    "\x07\t\x07\x04\b\t\b\x04\t\t\t\x04\n\t\n\x04\v\t\v\x04\f\t\f\x04\r\t\r" +
    "\x04\x0E\t\x0E\x04\x0F\t\x0F\x04\x10\t\x10\x04\x11\t\x11\x04\x12\t\x12" +
    "\x03\x02\x03\x02\x03\x02\x03\x02\x03\x03\x03\x03\x03\x04\x03\x04\x03\x05" +
    "\x03\x05\x03\x06\x03\x06\x03\x07\x03\x07\x03\b\x03\b\x03\t\x03\t\x03\n" +
    "\x03\n\x03\v\x03\v\x03\v\x03\v\x03\v\x03\v\x03\f\x03\f\x03\f\x03\f\x03" +
    "\f\x03\f\x03\r\x03\r\x03\r\x03\r\x03\r\x03\r\x03\r\x03\x0E\x03\x0E\x03" +
    "\x0F\x03\x0F\x03\x10\x06\x10R\n\x10\r\x10\x0E\x10S\x03\x11\x03\x11\x03" +
    "\x12\x06\x12Y\n\x12\r\x12\x0E\x12Z\x03\x12\x03\x12\x02\x02\x02\x13\x03" +
    "\x02\x03\x05\x02\x04\x07\x02\x05\t\x02\x06\v\x02\x07\r\x02\b\x0F\x02\t" +
    "\x11\x02\n\x13\x02\v\x15\x02\f\x17\x02\r\x19\x02\x0E\x1B\x02\x0F\x1D\x02" +
    "\x10\x1F\x02\x11!\x02\x12#\x02\x13\x03\x02\x04\x03\x022;\x05\x02\v\f\x0F" +
    "\x0F\"\"\x02_\x02\x03\x03\x02\x02\x02\x02\x05\x03\x02\x02\x02\x02\x07" +
    "\x03\x02\x02\x02\x02\t\x03\x02\x02\x02\x02\v\x03\x02\x02\x02\x02\r\x03" +
    "\x02\x02\x02\x02\x0F\x03\x02\x02\x02\x02\x11\x03\x02\x02\x02\x02\x13\x03" +
    "\x02\x02\x02\x02\x15\x03\x02\x02\x02\x02\x17\x03\x02\x02\x02\x02\x19\x03" +
    "\x02\x02\x02\x02\x1B\x03\x02\x02\x02\x02\x1D\x03\x02\x02\x02\x02\x1F\x03" +
    "\x02\x02\x02\x02!\x03\x02\x02\x02\x02#\x03\x02\x02\x02\x03%\x03\x02\x02" +
    "\x02\x05)\x03\x02\x02\x02\x07+\x03\x02\x02\x02\t-\x03\x02\x02\x02\v/\x03" +
    "\x02\x02\x02\r1\x03\x02\x02\x02\x0F3\x03\x02\x02\x02\x115\x03\x02\x02" +
    "\x02\x137\x03\x02\x02\x02\x159\x03\x02\x02\x02\x17?\x03\x02\x02\x02\x19" +
    "E\x03\x02\x02\x02\x1BL\x03\x02\x02\x02\x1DN\x03\x02\x02\x02\x1FQ\x03\x02" +
    "\x02\x02!U\x03\x02\x02\x02#X\x03\x02\x02\x02%&\x07p\x02\x02&\'\x07q\x02" +
    "\x02\'(\x07y\x02\x02(\x04\x03\x02\x02\x02)*\x07u\x02\x02*\x06\x03\x02" +
    "\x02\x02+,\x07o\x02\x02,\b\x03\x02\x02\x02-.\x07j\x02\x02.\n\x03\x02\x02" +
    "\x02/0\x07f\x02\x020\f\x03\x02\x02\x0212\x07y\x02\x022\x0E\x03\x02\x02" +
    "\x0234\x07O\x02\x024\x10\x03\x02\x02\x0256\x07S\x02\x026\x12\x03\x02\x02" +
    "\x0278\x07[\x02\x028\x14\x03\x02\x02\x029:\x07t\x02\x02:;\x07c\x02\x02" +
    ";<\x07p\x02\x02<=\x07i\x02\x02=>\x07g\x02\x02>\x16\x03\x02\x02\x02?@\x07" +
    "v\x02\x02@A\x07t\x02\x02AB\x07c\x02\x02BC\x07k\x02\x02CD\x07n\x02\x02" +
    "D\x18\x03\x02\x02\x02EF\x07r\x02\x02FG\x07g\x02\x02GH\x07t\x02\x02HI\x07" +
    "k\x02\x02IJ\x07q\x02\x02JK\x07f\x02\x02K\x1A\x03\x02\x02\x02LM\x07/\x02" +
    "\x02M\x1C\x03\x02\x02\x02NO\x07-\x02\x02O\x1E\x03\x02\x02\x02PR\t\x02" +
    "\x02\x02QP\x03\x02\x02\x02RS\x03\x02\x02\x02SQ\x03\x02\x02\x02ST\x03\x02" +
    "\x02\x02T \x03\x02\x02\x02UV\x07&\x02\x02V\"\x03\x02\x02\x02WY\t\x03\x02" +
    "\x02XW\x03\x02\x02\x02YZ\x03\x02\x02\x02ZX\x03\x02\x02\x02Z[\x03\x02\x02" +
    "\x02[\\\x03\x02\x02\x02\\]\b\x12\x02\x02]$\x03\x02\x02\x02\x05\x02SZ\x03" +
    "\b\x02\x02";
exports.RelativeDateFormatLexer = RelativeDateFormatLexer;
