"use strict";
// Generated from ./grammar/v1/RelativeDateFormat.g4 by ANTLR 4.7.3-SNAPSHOT
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ATN_1 = require("antlr4ts/atn/ATN");
const ATNDeserializer_1 = require("antlr4ts/atn/ATNDeserializer");
const FailedPredicateException_1 = require("antlr4ts/FailedPredicateException");
const NoViableAltException_1 = require("antlr4ts/NoViableAltException");
const Parser_1 = require("antlr4ts/Parser");
const ParserRuleContext_1 = require("antlr4ts/ParserRuleContext");
const ParserATNSimulator_1 = require("antlr4ts/atn/ParserATNSimulator");
const RecognitionException_1 = require("antlr4ts/RecognitionException");
const Token_1 = require("antlr4ts/Token");
const VocabularyImpl_1 = require("antlr4ts/VocabularyImpl");
const Utils = __importStar(require("antlr4ts/misc/Utils"));
class RelativeDateFormatParser extends Parser_1.Parser {
    constructor(input) {
        super(input);
        this._interp = new ParserATNSimulator_1.ParserATNSimulator(RelativeDateFormatParser._ATN, this);
    }
    // @Override
    // @NotNull
    get vocabulary() {
        return RelativeDateFormatParser.VOCABULARY;
    }
    // tslint:enable:no-trailing-whitespace
    // @Override
    get grammarFileName() { return "RelativeDateFormat.g4"; }
    // @Override
    get ruleNames() { return RelativeDateFormatParser.ruleNames; }
    // @Override
    get serializedATN() { return RelativeDateFormatParser._serializedATN; }
    // @RuleVersion(0)
    directive() {
        let _localctx = new DirectiveContext(this._ctx, this.state);
        this.enterRule(_localctx, 0, RelativeDateFormatParser.RULE_directive);
        let _la;
        try {
            this.state = 50;
            this._errHandler.sync(this);
            switch (this.interpreter.adaptivePredict(this._input, 1, this._ctx)) {
                case 1:
                    _localctx = new RangeDirectiveContext(_localctx);
                    this.enterOuterAlt(_localctx, 1);
                    {
                        this.state = 22;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                        this.state = 23;
                        this.match(RelativeDateFormatParser.RANGE);
                        this.state = 24;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                        this.state = 25;
                        _localctx._begin = this.resolvableExpression();
                        this.state = 26;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                        this.state = 27;
                        _localctx._end = this.resolvableExpression();
                        this.state = 28;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                    }
                    break;
                case 2:
                    _localctx = new TrailDirectiveContext(_localctx);
                    this.enterOuterAlt(_localctx, 2);
                    {
                        this.state = 30;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                        this.state = 31;
                        this.match(RelativeDateFormatParser.TRAIL);
                        this.state = 32;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                        this.state = 33;
                        _localctx._end = this.resolvableExpression();
                        this.state = 34;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                        {
                            this.state = 35;
                            _localctx._period = this.relativeExpression();
                        }
                        this.state = 36;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                    }
                    break;
                case 3:
                    _localctx = new PeriodDirectiveContext(_localctx);
                    this.enterOuterAlt(_localctx, 3);
                    {
                        this.state = 38;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                        this.state = 39;
                        this.match(RelativeDateFormatParser.PERIOD);
                        this.state = 40;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                        this.state = 41;
                        _localctx._begin = this.resolvableExpression();
                        this.state = 42;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                        {
                            this.state = 43;
                            _localctx._period = this.relativeExpression();
                        }
                        this.state = 44;
                        this.match(RelativeDateFormatParser.SEPERATOR);
                        this.state = 48;
                        this._errHandler.sync(this);
                        _la = this._input.LA(1);
                        if ((((_la) & ~0x1F) === 0 && ((1 << _la) & ((1 << RelativeDateFormatParser.NOW) | (1 << RelativeDateFormatParser.OP_MIN) | (1 << RelativeDateFormatParser.OP_ADD) | (1 << RelativeDateFormatParser.NUMBER))) !== 0)) {
                            {
                                this.state = 45;
                                _localctx._ref = this.resolvableExpression();
                                this.state = 46;
                                this.match(RelativeDateFormatParser.SEPERATOR);
                            }
                        }
                    }
                    break;
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.exitRule();
        }
        return _localctx;
    }
    // @RuleVersion(0)
    relativeExpression() {
        let _localctx = new RelativeExpressionContext(this._ctx, this.state);
        this.enterRule(_localctx, 2, RelativeDateFormatParser.RULE_relativeExpression);
        try {
            this.enterOuterAlt(_localctx, 1);
            {
                this.state = 54;
                this._errHandler.sync(this);
                switch (this.interpreter.adaptivePredict(this._input, 2, this._ctx)) {
                    case 1:
                        {
                            this.state = 52;
                            this.resolvableExpression();
                        }
                        break;
                    case 2:
                        {
                            this.state = 53;
                            this.relativePeriod();
                        }
                        break;
                }
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.exitRule();
        }
        return _localctx;
    }
    // @RuleVersion(0)
    resolvableExpression() {
        let _localctx = new ResolvableExpressionContext(this._ctx, this.state);
        this.enterRule(_localctx, 4, RelativeDateFormatParser.RULE_resolvableExpression);
        let _la;
        try {
            this.enterOuterAlt(_localctx, 1);
            {
                this.state = 58;
                this._errHandler.sync(this);
                switch (this.interpreter.adaptivePredict(this._input, 3, this._ctx)) {
                    case 1:
                        {
                            this.state = 56;
                            this.staticPeriod();
                        }
                        break;
                    case 2:
                        {
                            this.state = 57;
                            this.staticExpression(0);
                        }
                        break;
                }
                this.state = 61;
                this._errHandler.sync(this);
                _la = this._input.LA(1);
                if ((((_la) & ~0x1F) === 0 && ((1 << _la) & ((1 << RelativeDateFormatParser.OP_MIN) | (1 << RelativeDateFormatParser.OP_ADD) | (1 << RelativeDateFormatParser.NUMBER))) !== 0)) {
                    {
                        this.state = 60;
                        _localctx._rel = this.relativePeriod();
                    }
                }
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.exitRule();
        }
        return _localctx;
    }
    // @RuleVersion(0)
    staticExpression(_p) {
        if (_p === undefined) {
            _p = 0;
        }
        let _parentctx = this._ctx;
        let _parentState = this.state;
        let _localctx = new StaticExpressionContext(this._ctx, _parentState);
        let _prevctx = _localctx;
        let _startState = 6;
        this.enterRecursionRule(_localctx, 6, RelativeDateFormatParser.RULE_staticExpression, _p);
        try {
            let _alt;
            this.enterOuterAlt(_localctx, 1);
            {
                {
                    this.state = 66;
                    this._errHandler.sync(this);
                    switch (this._input.LA(1)) {
                        case RelativeDateFormatParser.NUMBER:
                            {
                                this.state = 64;
                                this.timestamp();
                            }
                            break;
                        case RelativeDateFormatParser.NOW:
                            {
                                this.state = 65;
                                this.match(RelativeDateFormatParser.NOW);
                            }
                            break;
                        default:
                            throw new NoViableAltException_1.NoViableAltException(this);
                    }
                }
                this._ctx._stop = this._input.tryLT(-1);
                this.state = 76;
                this._errHandler.sync(this);
                _alt = this.interpreter.adaptivePredict(this._input, 7, this._ctx);
                while (_alt !== 2 && _alt !== ATN_1.ATN.INVALID_ALT_NUMBER) {
                    if (_alt === 1) {
                        if (this._parseListeners != null) {
                            this.triggerExitRuleEvent();
                        }
                        _prevctx = _localctx;
                        {
                            {
                                _localctx = new StaticExpressionContext(_parentctx, _parentState);
                                _localctx._first = _prevctx;
                                this.pushNewRecursionContext(_localctx, _startState, RelativeDateFormatParser.RULE_staticExpression);
                                this.state = 68;
                                if (!(this.precpred(this._ctx, 1))) {
                                    throw new FailedPredicateException_1.FailedPredicateException(this, "this.precpred(this._ctx, 1)");
                                }
                                this.state = 70;
                                this._errHandler.sync(this);
                                _alt = 1;
                                do {
                                    switch (_alt) {
                                        case 1:
                                            {
                                                {
                                                    this.state = 69;
                                                    _localctx._staticPeriod = this.staticPeriod();
                                                    _localctx._then.push(_localctx._staticPeriod);
                                                }
                                            }
                                            break;
                                        default:
                                            throw new NoViableAltException_1.NoViableAltException(this);
                                    }
                                    this.state = 72;
                                    this._errHandler.sync(this);
                                    _alt = this.interpreter.adaptivePredict(this._input, 6, this._ctx);
                                } while (_alt !== 2 && _alt !== ATN_1.ATN.INVALID_ALT_NUMBER);
                            }
                        }
                    }
                    this.state = 78;
                    this._errHandler.sync(this);
                    _alt = this.interpreter.adaptivePredict(this._input, 7, this._ctx);
                }
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.unrollRecursionContexts(_parentctx);
        }
        return _localctx;
    }
    // @RuleVersion(0)
    staticPeriod() {
        let _localctx = new StaticPeriodContext(this._ctx, this.state);
        this.enterRule(_localctx, 8, RelativeDateFormatParser.RULE_staticPeriod);
        try {
            this.state = 84;
            this._errHandler.sync(this);
            switch (this._input.LA(1)) {
                case RelativeDateFormatParser.OP_MIN:
                case RelativeDateFormatParser.OP_ADD:
                    this.enterOuterAlt(_localctx, 1);
                    {
                        this.state = 79;
                        this.unaryExpr();
                        this.state = 80;
                        this.staticIdentifier();
                    }
                    break;
                case RelativeDateFormatParser.NUMBER:
                    this.enterOuterAlt(_localctx, 2);
                    {
                        this.state = 82;
                        this.match(RelativeDateFormatParser.NUMBER);
                        this.state = 83;
                        this.staticIdentifier();
                    }
                    break;
                default:
                    throw new NoViableAltException_1.NoViableAltException(this);
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.exitRule();
        }
        return _localctx;
    }
    // @RuleVersion(0)
    relativePeriod() {
        let _localctx = new RelativePeriodContext(this._ctx, this.state);
        this.enterRule(_localctx, 10, RelativeDateFormatParser.RULE_relativePeriod);
        try {
            this.state = 91;
            this._errHandler.sync(this);
            switch (this._input.LA(1)) {
                case RelativeDateFormatParser.OP_MIN:
                case RelativeDateFormatParser.OP_ADD:
                    this.enterOuterAlt(_localctx, 1);
                    {
                        this.state = 86;
                        this.unaryExpr();
                        this.state = 87;
                        this.relativeIdentifier();
                    }
                    break;
                case RelativeDateFormatParser.NUMBER:
                    this.enterOuterAlt(_localctx, 2);
                    {
                        this.state = 89;
                        this.match(RelativeDateFormatParser.NUMBER);
                        this.state = 90;
                        this.relativeIdentifier();
                    }
                    break;
                default:
                    throw new NoViableAltException_1.NoViableAltException(this);
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.exitRule();
        }
        return _localctx;
    }
    // @RuleVersion(0)
    unaryExpr() {
        let _localctx = new UnaryExprContext(this._ctx, this.state);
        this.enterRule(_localctx, 12, RelativeDateFormatParser.RULE_unaryExpr);
        try {
            this.state = 97;
            this._errHandler.sync(this);
            switch (this._input.LA(1)) {
                case RelativeDateFormatParser.OP_ADD:
                    _localctx = new PosUnaryExprContext(_localctx);
                    this.enterOuterAlt(_localctx, 1);
                    {
                        this.state = 93;
                        this.match(RelativeDateFormatParser.OP_ADD);
                        this.state = 94;
                        this.match(RelativeDateFormatParser.NUMBER);
                    }
                    break;
                case RelativeDateFormatParser.OP_MIN:
                    _localctx = new NegUnaryExprContext(_localctx);
                    this.enterOuterAlt(_localctx, 2);
                    {
                        this.state = 95;
                        this.match(RelativeDateFormatParser.OP_MIN);
                        this.state = 96;
                        this.match(RelativeDateFormatParser.NUMBER);
                    }
                    break;
                default:
                    throw new NoViableAltException_1.NoViableAltException(this);
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.exitRule();
        }
        return _localctx;
    }
    // @RuleVersion(0)
    staticIdentifier() {
        let _localctx = new StaticIdentifierContext(this._ctx, this.state);
        this.enterRule(_localctx, 14, RelativeDateFormatParser.RULE_staticIdentifier);
        let _la;
        try {
            this.enterOuterAlt(_localctx, 1);
            {
                this.state = 99;
                _la = this._input.LA(1);
                if (!((((_la) & ~0x1F) === 0 && ((1 << _la) & ((1 << RelativeDateFormatParser.SECONDS) | (1 << RelativeDateFormatParser.MINUTES) | (1 << RelativeDateFormatParser.HOURS) | (1 << RelativeDateFormatParser.DAYS) | (1 << RelativeDateFormatParser.WEEKS))) !== 0))) {
                    this._errHandler.recoverInline(this);
                }
                else {
                    if (this._input.LA(1) === Token_1.Token.EOF) {
                        this.matchedEOF = true;
                    }
                    this._errHandler.reportMatch(this);
                    this.consume();
                }
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.exitRule();
        }
        return _localctx;
    }
    // @RuleVersion(0)
    relativeIdentifier() {
        let _localctx = new RelativeIdentifierContext(this._ctx, this.state);
        this.enterRule(_localctx, 16, RelativeDateFormatParser.RULE_relativeIdentifier);
        let _la;
        try {
            this.enterOuterAlt(_localctx, 1);
            {
                this.state = 101;
                _la = this._input.LA(1);
                if (!((((_la) & ~0x1F) === 0 && ((1 << _la) & ((1 << RelativeDateFormatParser.MONTHS) | (1 << RelativeDateFormatParser.QUARTERS) | (1 << RelativeDateFormatParser.YEARS))) !== 0))) {
                    this._errHandler.recoverInline(this);
                }
                else {
                    if (this._input.LA(1) === Token_1.Token.EOF) {
                        this.matchedEOF = true;
                    }
                    this._errHandler.reportMatch(this);
                    this.consume();
                }
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.exitRule();
        }
        return _localctx;
    }
    // @RuleVersion(0)
    handler() {
        let _localctx = new HandlerContext(this._ctx, this.state);
        this.enterRule(_localctx, 18, RelativeDateFormatParser.RULE_handler);
        let _la;
        try {
            this.enterOuterAlt(_localctx, 1);
            {
                this.state = 103;
                _la = this._input.LA(1);
                if (!((((_la) & ~0x1F) === 0 && ((1 << _la) & ((1 << RelativeDateFormatParser.RANGE) | (1 << RelativeDateFormatParser.TRAIL) | (1 << RelativeDateFormatParser.PERIOD))) !== 0))) {
                    this._errHandler.recoverInline(this);
                }
                else {
                    if (this._input.LA(1) === Token_1.Token.EOF) {
                        this.matchedEOF = true;
                    }
                    this._errHandler.reportMatch(this);
                    this.consume();
                }
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.exitRule();
        }
        return _localctx;
    }
    // @RuleVersion(0)
    timestamp() {
        let _localctx = new TimestampContext(this._ctx, this.state);
        this.enterRule(_localctx, 20, RelativeDateFormatParser.RULE_timestamp);
        try {
            let _alt;
            this.enterOuterAlt(_localctx, 1);
            {
                this.state = 106;
                this._errHandler.sync(this);
                _alt = 1;
                do {
                    switch (_alt) {
                        case 1:
                            {
                                {
                                    this.state = 105;
                                    this.match(RelativeDateFormatParser.NUMBER);
                                }
                            }
                            break;
                        default:
                            throw new NoViableAltException_1.NoViableAltException(this);
                    }
                    this.state = 108;
                    this._errHandler.sync(this);
                    _alt = this.interpreter.adaptivePredict(this._input, 11, this._ctx);
                } while (_alt !== 2 && _alt !== ATN_1.ATN.INVALID_ALT_NUMBER);
            }
        }
        catch (re) {
            if (re instanceof RecognitionException_1.RecognitionException) {
                _localctx.exception = re;
                this._errHandler.reportError(this, re);
                this._errHandler.recover(this, re);
            }
            else {
                throw re;
            }
        }
        finally {
            this.exitRule();
        }
        return _localctx;
    }
    sempred(_localctx, ruleIndex, predIndex) {
        switch (ruleIndex) {
            case 3:
                return this.staticExpression_sempred(_localctx, predIndex);
        }
        return true;
    }
    staticExpression_sempred(_localctx, predIndex) {
        switch (predIndex) {
            case 0:
                return this.precpred(this._ctx, 1);
        }
        return true;
    }
    static get _ATN() {
        if (!RelativeDateFormatParser.__ATN) {
            RelativeDateFormatParser.__ATN = new ATNDeserializer_1.ATNDeserializer().deserialize(Utils.toCharArray(RelativeDateFormatParser._serializedATN));
        }
        return RelativeDateFormatParser.__ATN;
    }
}
RelativeDateFormatParser.NOW = 1;
RelativeDateFormatParser.SECONDS = 2;
RelativeDateFormatParser.MINUTES = 3;
RelativeDateFormatParser.HOURS = 4;
RelativeDateFormatParser.DAYS = 5;
RelativeDateFormatParser.WEEKS = 6;
RelativeDateFormatParser.MONTHS = 7;
RelativeDateFormatParser.QUARTERS = 8;
RelativeDateFormatParser.YEARS = 9;
RelativeDateFormatParser.RANGE = 10;
RelativeDateFormatParser.TRAIL = 11;
RelativeDateFormatParser.PERIOD = 12;
RelativeDateFormatParser.OP_MIN = 13;
RelativeDateFormatParser.OP_ADD = 14;
RelativeDateFormatParser.NUMBER = 15;
RelativeDateFormatParser.SEPERATOR = 16;
RelativeDateFormatParser.WS = 17;
RelativeDateFormatParser.RULE_directive = 0;
RelativeDateFormatParser.RULE_relativeExpression = 1;
RelativeDateFormatParser.RULE_resolvableExpression = 2;
RelativeDateFormatParser.RULE_staticExpression = 3;
RelativeDateFormatParser.RULE_staticPeriod = 4;
RelativeDateFormatParser.RULE_relativePeriod = 5;
RelativeDateFormatParser.RULE_unaryExpr = 6;
RelativeDateFormatParser.RULE_staticIdentifier = 7;
RelativeDateFormatParser.RULE_relativeIdentifier = 8;
RelativeDateFormatParser.RULE_handler = 9;
RelativeDateFormatParser.RULE_timestamp = 10;
// tslint:disable:no-trailing-whitespace
RelativeDateFormatParser.ruleNames = [
    "directive", "relativeExpression", "resolvableExpression", "staticExpression",
    "staticPeriod", "relativePeriod", "unaryExpr", "staticIdentifier", "relativeIdentifier",
    "handler", "timestamp",
];
RelativeDateFormatParser._LITERAL_NAMES = [
    undefined, "'now'", "'s'", "'m'", "'h'", "'d'", "'w'", "'M'", "'Q'", "'Y'",
    "'range'", "'trail'", "'period'", "'-'", "'+'", undefined, "'$'",
];
RelativeDateFormatParser._SYMBOLIC_NAMES = [
    undefined, "NOW", "SECONDS", "MINUTES", "HOURS", "DAYS", "WEEKS", "MONTHS",
    "QUARTERS", "YEARS", "RANGE", "TRAIL", "PERIOD", "OP_MIN", "OP_ADD", "NUMBER",
    "SEPERATOR", "WS",
];
RelativeDateFormatParser.VOCABULARY = new VocabularyImpl_1.VocabularyImpl(RelativeDateFormatParser._LITERAL_NAMES, RelativeDateFormatParser._SYMBOLIC_NAMES, []);
RelativeDateFormatParser._serializedATN = "\x03\uC91D\uCABA\u058D\uAFBA\u4F53\u0607\uEA8B\uC241\x03\x13q\x04\x02" +
    "\t\x02\x04\x03\t\x03\x04\x04\t\x04\x04\x05\t\x05\x04\x06\t\x06\x04\x07" +
    "\t\x07\x04\b\t\b\x04\t\t\t\x04\n\t\n\x04\v\t\v\x04\f\t\f\x03\x02\x03\x02" +
    "\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02" +
    "\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02" +
    "\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02\x03\x02\x05\x023\n\x02\x05\x02" +
    "5\n\x02\x03\x03\x03\x03\x05\x039\n\x03\x03\x04\x03\x04\x05\x04=\n\x04" +
    "\x03\x04\x05\x04@\n\x04\x03\x05\x03\x05\x03\x05\x05\x05E\n\x05\x03\x05" +
    "\x03\x05\x06\x05I\n\x05\r\x05\x0E\x05J\x07\x05M\n\x05\f\x05\x0E\x05P\v" +
    "\x05\x03\x06\x03\x06\x03\x06\x03\x06\x03\x06\x05\x06W\n\x06\x03\x07\x03" +
    "\x07\x03\x07\x03\x07\x03\x07\x05\x07^\n\x07\x03\b\x03\b\x03\b\x03\b\x05" +
    "\bd\n\b\x03\t\x03\t\x03\n\x03\n\x03\v\x03\v\x03\f\x06\fm\n\f\r\f\x0E\f" +
    "n\x03\f\x02\x02\x03\b\r\x02\x02\x04\x02\x06\x02\b\x02\n\x02\f\x02\x0E" +
    "\x02\x10\x02\x12\x02\x14\x02\x16\x02\x02\x05\x03\x02\x04\b\x03\x02\t\v" +
    "\x03\x02\f\x0E\x02r\x024\x03\x02\x02\x02\x048\x03\x02\x02\x02\x06<\x03" +
    "\x02\x02\x02\bA\x03\x02\x02\x02\nV\x03\x02\x02\x02\f]\x03\x02\x02\x02" +
    "\x0Ec\x03\x02\x02\x02\x10e\x03\x02\x02\x02\x12g\x03\x02\x02\x02\x14i\x03" +
    "\x02\x02\x02\x16l\x03\x02\x02\x02\x18\x19\x07\x12\x02\x02\x19\x1A\x07" +
    "\f\x02\x02\x1A\x1B\x07\x12\x02\x02\x1B\x1C\x05\x06\x04\x02\x1C\x1D\x07" +
    "\x12\x02\x02\x1D\x1E\x05\x06\x04\x02\x1E\x1F\x07\x12\x02\x02\x1F5\x03" +
    "\x02\x02\x02 !\x07\x12\x02\x02!\"\x07\r\x02\x02\"#\x07\x12\x02\x02#$\x05" +
    "\x06\x04\x02$%\x07\x12\x02\x02%&\x05\x04\x03\x02&\'\x07\x12\x02\x02\'" +
    "5\x03\x02\x02\x02()\x07\x12\x02\x02)*\x07\x0E\x02\x02*+\x07\x12\x02\x02" +
    "+,\x05\x06\x04\x02,-\x07\x12\x02\x02-.\x05\x04\x03\x02.2\x07\x12\x02\x02" +
    "/0\x05\x06\x04\x0201\x07\x12\x02\x0213\x03\x02\x02\x022/\x03\x02\x02\x02" +
    "23\x03\x02\x02\x0235\x03\x02\x02\x024\x18\x03\x02\x02\x024 \x03\x02\x02" +
    "\x024(\x03\x02\x02\x025\x03\x03\x02\x02\x0269\x05\x06\x04\x0279\x05\f" +
    "\x07\x0286\x03\x02\x02\x0287\x03\x02\x02\x029\x05\x03\x02\x02\x02:=\x05" +
    "\n\x06\x02;=\x05\b\x05\x02<:\x03\x02\x02\x02<;\x03\x02\x02\x02=?\x03\x02" +
    "\x02\x02>@\x05\f\x07\x02?>\x03\x02\x02\x02?@\x03\x02\x02\x02@\x07\x03" +
    "\x02\x02\x02AD\b\x05\x01\x02BE\x05\x16\f\x02CE\x07\x03\x02\x02DB\x03\x02" +
    "\x02\x02DC\x03\x02\x02\x02EN\x03\x02\x02\x02FH\f\x03\x02\x02GI\x05\n\x06" +
    "\x02HG\x03\x02\x02\x02IJ\x03\x02\x02\x02JH\x03\x02\x02\x02JK\x03\x02\x02" +
    "\x02KM\x03\x02\x02\x02LF\x03\x02\x02\x02MP\x03\x02\x02\x02NL\x03\x02\x02" +
    "\x02NO\x03\x02\x02\x02O\t\x03\x02\x02\x02PN\x03\x02\x02\x02QR\x05\x0E" +
    "\b\x02RS\x05\x10\t\x02SW\x03\x02\x02\x02TU\x07\x11\x02\x02UW\x05\x10\t" +
    "\x02VQ\x03\x02\x02\x02VT\x03\x02\x02\x02W\v\x03\x02\x02\x02XY\x05\x0E" +
    "\b\x02YZ\x05\x12\n\x02Z^\x03\x02\x02\x02[\\\x07\x11\x02\x02\\^\x05\x12" +
    "\n\x02]X\x03\x02\x02\x02][\x03\x02\x02\x02^\r\x03\x02\x02\x02_`\x07\x10" +
    "\x02\x02`d\x07\x11\x02\x02ab\x07\x0F\x02\x02bd\x07\x11\x02\x02c_\x03\x02" +
    "\x02\x02ca\x03\x02\x02\x02d\x0F\x03\x02\x02\x02ef\t\x02\x02\x02f\x11\x03" +
    "\x02\x02\x02gh\t\x03\x02\x02h\x13\x03\x02\x02\x02ij\t\x04\x02\x02j\x15" +
    "\x03\x02\x02\x02km\x07\x11\x02\x02lk\x03\x02\x02\x02mn\x03\x02\x02\x02" +
    "nl\x03\x02\x02\x02no\x03\x02\x02\x02o\x17\x03\x02\x02\x02\x0E248<?DJN" +
    "V]cn";
exports.RelativeDateFormatParser = RelativeDateFormatParser;
class DirectiveContext extends ParserRuleContext_1.ParserRuleContext {
    constructor(parent, invokingState) {
        super(parent, invokingState);
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_directive; }
    copyFrom(ctx) {
        super.copyFrom(ctx);
    }
}
exports.DirectiveContext = DirectiveContext;
class RangeDirectiveContext extends DirectiveContext {
    SEPERATOR(i) {
        if (i === undefined) {
            return this.getTokens(RelativeDateFormatParser.SEPERATOR);
        }
        else {
            return this.getToken(RelativeDateFormatParser.SEPERATOR, i);
        }
    }
    RANGE() { return this.getToken(RelativeDateFormatParser.RANGE, 0); }
    resolvableExpression(i) {
        if (i === undefined) {
            return this.getRuleContexts(ResolvableExpressionContext);
        }
        else {
            return this.getRuleContext(i, ResolvableExpressionContext);
        }
    }
    constructor(ctx) {
        super(ctx.parent, ctx.invokingState);
        this.copyFrom(ctx);
    }
    // @Override
    enterRule(listener) {
        if (listener.enterRangeDirective) {
            listener.enterRangeDirective(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitRangeDirective) {
            listener.exitRangeDirective(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitRangeDirective) {
            return visitor.visitRangeDirective(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.RangeDirectiveContext = RangeDirectiveContext;
class TrailDirectiveContext extends DirectiveContext {
    SEPERATOR(i) {
        if (i === undefined) {
            return this.getTokens(RelativeDateFormatParser.SEPERATOR);
        }
        else {
            return this.getToken(RelativeDateFormatParser.SEPERATOR, i);
        }
    }
    TRAIL() { return this.getToken(RelativeDateFormatParser.TRAIL, 0); }
    resolvableExpression() {
        return this.getRuleContext(0, ResolvableExpressionContext);
    }
    relativeExpression() {
        return this.tryGetRuleContext(0, RelativeExpressionContext);
    }
    constructor(ctx) {
        super(ctx.parent, ctx.invokingState);
        this.copyFrom(ctx);
    }
    // @Override
    enterRule(listener) {
        if (listener.enterTrailDirective) {
            listener.enterTrailDirective(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitTrailDirective) {
            listener.exitTrailDirective(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitTrailDirective) {
            return visitor.visitTrailDirective(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.TrailDirectiveContext = TrailDirectiveContext;
class PeriodDirectiveContext extends DirectiveContext {
    SEPERATOR(i) {
        if (i === undefined) {
            return this.getTokens(RelativeDateFormatParser.SEPERATOR);
        }
        else {
            return this.getToken(RelativeDateFormatParser.SEPERATOR, i);
        }
    }
    PERIOD() { return this.getToken(RelativeDateFormatParser.PERIOD, 0); }
    resolvableExpression(i) {
        if (i === undefined) {
            return this.getRuleContexts(ResolvableExpressionContext);
        }
        else {
            return this.getRuleContext(i, ResolvableExpressionContext);
        }
    }
    relativeExpression() {
        return this.tryGetRuleContext(0, RelativeExpressionContext);
    }
    constructor(ctx) {
        super(ctx.parent, ctx.invokingState);
        this.copyFrom(ctx);
    }
    // @Override
    enterRule(listener) {
        if (listener.enterPeriodDirective) {
            listener.enterPeriodDirective(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitPeriodDirective) {
            listener.exitPeriodDirective(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitPeriodDirective) {
            return visitor.visitPeriodDirective(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.PeriodDirectiveContext = PeriodDirectiveContext;
class RelativeExpressionContext extends ParserRuleContext_1.ParserRuleContext {
    resolvableExpression() {
        return this.tryGetRuleContext(0, ResolvableExpressionContext);
    }
    relativePeriod() {
        return this.tryGetRuleContext(0, RelativePeriodContext);
    }
    constructor(parent, invokingState) {
        super(parent, invokingState);
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_relativeExpression; }
    // @Override
    enterRule(listener) {
        if (listener.enterRelativeExpression) {
            listener.enterRelativeExpression(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitRelativeExpression) {
            listener.exitRelativeExpression(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitRelativeExpression) {
            return visitor.visitRelativeExpression(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.RelativeExpressionContext = RelativeExpressionContext;
class ResolvableExpressionContext extends ParserRuleContext_1.ParserRuleContext {
    staticPeriod() {
        return this.tryGetRuleContext(0, StaticPeriodContext);
    }
    staticExpression() {
        return this.tryGetRuleContext(0, StaticExpressionContext);
    }
    relativePeriod() {
        return this.tryGetRuleContext(0, RelativePeriodContext);
    }
    constructor(parent, invokingState) {
        super(parent, invokingState);
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_resolvableExpression; }
    // @Override
    enterRule(listener) {
        if (listener.enterResolvableExpression) {
            listener.enterResolvableExpression(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitResolvableExpression) {
            listener.exitResolvableExpression(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitResolvableExpression) {
            return visitor.visitResolvableExpression(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.ResolvableExpressionContext = ResolvableExpressionContext;
class StaticExpressionContext extends ParserRuleContext_1.ParserRuleContext {
    constructor(parent, invokingState) {
        super(parent, invokingState);
        this._then = [];
    }
    timestamp() {
        return this.tryGetRuleContext(0, TimestampContext);
    }
    NOW() { return this.tryGetToken(RelativeDateFormatParser.NOW, 0); }
    staticExpression() {
        return this.tryGetRuleContext(0, StaticExpressionContext);
    }
    staticPeriod(i) {
        if (i === undefined) {
            return this.getRuleContexts(StaticPeriodContext);
        }
        else {
            return this.getRuleContext(i, StaticPeriodContext);
        }
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_staticExpression; }
    // @Override
    enterRule(listener) {
        if (listener.enterStaticExpression) {
            listener.enterStaticExpression(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitStaticExpression) {
            listener.exitStaticExpression(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitStaticExpression) {
            return visitor.visitStaticExpression(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.StaticExpressionContext = StaticExpressionContext;
class StaticPeriodContext extends ParserRuleContext_1.ParserRuleContext {
    unaryExpr() {
        return this.tryGetRuleContext(0, UnaryExprContext);
    }
    staticIdentifier() {
        return this.getRuleContext(0, StaticIdentifierContext);
    }
    NUMBER() { return this.tryGetToken(RelativeDateFormatParser.NUMBER, 0); }
    constructor(parent, invokingState) {
        super(parent, invokingState);
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_staticPeriod; }
    // @Override
    enterRule(listener) {
        if (listener.enterStaticPeriod) {
            listener.enterStaticPeriod(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitStaticPeriod) {
            listener.exitStaticPeriod(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitStaticPeriod) {
            return visitor.visitStaticPeriod(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.StaticPeriodContext = StaticPeriodContext;
class RelativePeriodContext extends ParserRuleContext_1.ParserRuleContext {
    unaryExpr() {
        return this.tryGetRuleContext(0, UnaryExprContext);
    }
    relativeIdentifier() {
        return this.getRuleContext(0, RelativeIdentifierContext);
    }
    NUMBER() { return this.tryGetToken(RelativeDateFormatParser.NUMBER, 0); }
    constructor(parent, invokingState) {
        super(parent, invokingState);
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_relativePeriod; }
    // @Override
    enterRule(listener) {
        if (listener.enterRelativePeriod) {
            listener.enterRelativePeriod(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitRelativePeriod) {
            listener.exitRelativePeriod(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitRelativePeriod) {
            return visitor.visitRelativePeriod(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.RelativePeriodContext = RelativePeriodContext;
class UnaryExprContext extends ParserRuleContext_1.ParserRuleContext {
    constructor(parent, invokingState) {
        super(parent, invokingState);
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_unaryExpr; }
    copyFrom(ctx) {
        super.copyFrom(ctx);
    }
}
exports.UnaryExprContext = UnaryExprContext;
class PosUnaryExprContext extends UnaryExprContext {
    OP_ADD() { return this.getToken(RelativeDateFormatParser.OP_ADD, 0); }
    NUMBER() { return this.getToken(RelativeDateFormatParser.NUMBER, 0); }
    constructor(ctx) {
        super(ctx.parent, ctx.invokingState);
        this.copyFrom(ctx);
    }
    // @Override
    enterRule(listener) {
        if (listener.enterPosUnaryExpr) {
            listener.enterPosUnaryExpr(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitPosUnaryExpr) {
            listener.exitPosUnaryExpr(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitPosUnaryExpr) {
            return visitor.visitPosUnaryExpr(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.PosUnaryExprContext = PosUnaryExprContext;
class NegUnaryExprContext extends UnaryExprContext {
    OP_MIN() { return this.getToken(RelativeDateFormatParser.OP_MIN, 0); }
    NUMBER() { return this.getToken(RelativeDateFormatParser.NUMBER, 0); }
    constructor(ctx) {
        super(ctx.parent, ctx.invokingState);
        this.copyFrom(ctx);
    }
    // @Override
    enterRule(listener) {
        if (listener.enterNegUnaryExpr) {
            listener.enterNegUnaryExpr(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitNegUnaryExpr) {
            listener.exitNegUnaryExpr(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitNegUnaryExpr) {
            return visitor.visitNegUnaryExpr(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.NegUnaryExprContext = NegUnaryExprContext;
class StaticIdentifierContext extends ParserRuleContext_1.ParserRuleContext {
    SECONDS() { return this.tryGetToken(RelativeDateFormatParser.SECONDS, 0); }
    MINUTES() { return this.tryGetToken(RelativeDateFormatParser.MINUTES, 0); }
    HOURS() { return this.tryGetToken(RelativeDateFormatParser.HOURS, 0); }
    DAYS() { return this.tryGetToken(RelativeDateFormatParser.DAYS, 0); }
    WEEKS() { return this.tryGetToken(RelativeDateFormatParser.WEEKS, 0); }
    constructor(parent, invokingState) {
        super(parent, invokingState);
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_staticIdentifier; }
    // @Override
    enterRule(listener) {
        if (listener.enterStaticIdentifier) {
            listener.enterStaticIdentifier(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitStaticIdentifier) {
            listener.exitStaticIdentifier(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitStaticIdentifier) {
            return visitor.visitStaticIdentifier(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.StaticIdentifierContext = StaticIdentifierContext;
class RelativeIdentifierContext extends ParserRuleContext_1.ParserRuleContext {
    MONTHS() { return this.tryGetToken(RelativeDateFormatParser.MONTHS, 0); }
    QUARTERS() { return this.tryGetToken(RelativeDateFormatParser.QUARTERS, 0); }
    YEARS() { return this.tryGetToken(RelativeDateFormatParser.YEARS, 0); }
    constructor(parent, invokingState) {
        super(parent, invokingState);
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_relativeIdentifier; }
    // @Override
    enterRule(listener) {
        if (listener.enterRelativeIdentifier) {
            listener.enterRelativeIdentifier(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitRelativeIdentifier) {
            listener.exitRelativeIdentifier(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitRelativeIdentifier) {
            return visitor.visitRelativeIdentifier(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.RelativeIdentifierContext = RelativeIdentifierContext;
class HandlerContext extends ParserRuleContext_1.ParserRuleContext {
    RANGE() { return this.tryGetToken(RelativeDateFormatParser.RANGE, 0); }
    TRAIL() { return this.tryGetToken(RelativeDateFormatParser.TRAIL, 0); }
    PERIOD() { return this.tryGetToken(RelativeDateFormatParser.PERIOD, 0); }
    constructor(parent, invokingState) {
        super(parent, invokingState);
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_handler; }
    // @Override
    enterRule(listener) {
        if (listener.enterHandler) {
            listener.enterHandler(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitHandler) {
            listener.exitHandler(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitHandler) {
            return visitor.visitHandler(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.HandlerContext = HandlerContext;
class TimestampContext extends ParserRuleContext_1.ParserRuleContext {
    NUMBER(i) {
        if (i === undefined) {
            return this.getTokens(RelativeDateFormatParser.NUMBER);
        }
        else {
            return this.getToken(RelativeDateFormatParser.NUMBER, i);
        }
    }
    constructor(parent, invokingState) {
        super(parent, invokingState);
    }
    // @Override
    get ruleIndex() { return RelativeDateFormatParser.RULE_timestamp; }
    // @Override
    enterRule(listener) {
        if (listener.enterTimestamp) {
            listener.enterTimestamp(this);
        }
    }
    // @Override
    exitRule(listener) {
        if (listener.exitTimestamp) {
            listener.exitTimestamp(this);
        }
    }
    // @Override
    accept(visitor) {
        if (visitor.visitTimestamp) {
            return visitor.visitTimestamp(this);
        }
        else {
            return visitor.visitChildren(this);
        }
    }
}
exports.TimestampContext = TimestampContext;
