"use strict";
/**
 * End to end tests of the RDF function
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("mocha");
const chai_1 = require("chai");
const index_1 = __importDefault(require("../index"));
describe.only("End to end tests", function () {
    // A lot of these cases are stolen from the Function Factory tests and run end to end for completeness
    var cases = [
        ["$range$1561872660$1561872880$", [1561872660, 1561872880]],
        ["$trail$1561872660$1Q$", [1553923860, 1561872660]],
        ["$period$1561872660$10s$1561872665$", [1561872660, 1561872670]]
    ];
    for (let test of cases) {
        it(`${test[0]}`, function () {
            chai_1.expect(index_1.default(test[0])).to.be.eql(test[1]);
        });
    }
});
