"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// A hacky solution to use the listener to emit errors. In production code all error behavoirs should be handled in the
// ANTLRErrorStrategy, but this way allows a quick shortcut for verbose error messages for debugging in test
class RDFTestingErrorHandler {
    syntaxError(_recognizer, _offendingSymbol, line, charPositionInLine, msg, _e) {
        throw new Error(`line ${line}:${charPositionInLine} ${msg}`);
    }
}
exports.RDFTestingErrorHandler = RDFTestingErrorHandler;
