// Generated from ./grammar/v1/RelativeDateFormat.g4 by ANTLR 4.7.3-SNAPSHOT


import { ParseTreeListener } from "antlr4ts/tree/ParseTreeListener";

import { PosUnaryExprContext } from "./RelativeDateFormatParser";
import { NegUnaryExprContext } from "./RelativeDateFormatParser";
import { RangeDirectiveContext } from "./RelativeDateFormatParser";
import { TrailDirectiveContext } from "./RelativeDateFormatParser";
import { PeriodDirectiveContext } from "./RelativeDateFormatParser";
import { DirectiveContext } from "./RelativeDateFormatParser";
import { RelativeExpressionContext } from "./RelativeDateFormatParser";
import { ResolvableExpressionContext } from "./RelativeDateFormatParser";
import { StaticExpressionContext } from "./RelativeDateFormatParser";
import { StaticPeriodContext } from "./RelativeDateFormatParser";
import { RelativePeriodContext } from "./RelativeDateFormatParser";
import { UnaryExprContext } from "./RelativeDateFormatParser";
import { StaticIdentifierContext } from "./RelativeDateFormatParser";
import { RelativeIdentifierContext } from "./RelativeDateFormatParser";
import { HandlerContext } from "./RelativeDateFormatParser";
import { TimestampContext } from "./RelativeDateFormatParser";


/**
 * This interface defines a complete listener for a parse tree produced by
 * `RelativeDateFormatParser`.
 */
export interface RelativeDateFormatListener extends ParseTreeListener {
	/**
	 * Enter a parse tree produced by the `posUnaryExpr`
	 * labeled alternative in `RelativeDateFormatParser.unaryExpr`.
	 * @param ctx the parse tree
	 */
	enterPosUnaryExpr?: (ctx: PosUnaryExprContext) => void;
	/**
	 * Exit a parse tree produced by the `posUnaryExpr`
	 * labeled alternative in `RelativeDateFormatParser.unaryExpr`.
	 * @param ctx the parse tree
	 */
	exitPosUnaryExpr?: (ctx: PosUnaryExprContext) => void;

	/**
	 * Enter a parse tree produced by the `negUnaryExpr`
	 * labeled alternative in `RelativeDateFormatParser.unaryExpr`.
	 * @param ctx the parse tree
	 */
	enterNegUnaryExpr?: (ctx: NegUnaryExprContext) => void;
	/**
	 * Exit a parse tree produced by the `negUnaryExpr`
	 * labeled alternative in `RelativeDateFormatParser.unaryExpr`.
	 * @param ctx the parse tree
	 */
	exitNegUnaryExpr?: (ctx: NegUnaryExprContext) => void;

	/**
	 * Enter a parse tree produced by the `RangeDirective`
	 * labeled alternative in `RelativeDateFormatParser.directive`.
	 * @param ctx the parse tree
	 */
	enterRangeDirective?: (ctx: RangeDirectiveContext) => void;
	/**
	 * Exit a parse tree produced by the `RangeDirective`
	 * labeled alternative in `RelativeDateFormatParser.directive`.
	 * @param ctx the parse tree
	 */
	exitRangeDirective?: (ctx: RangeDirectiveContext) => void;

	/**
	 * Enter a parse tree produced by the `TrailDirective`
	 * labeled alternative in `RelativeDateFormatParser.directive`.
	 * @param ctx the parse tree
	 */
	enterTrailDirective?: (ctx: TrailDirectiveContext) => void;
	/**
	 * Exit a parse tree produced by the `TrailDirective`
	 * labeled alternative in `RelativeDateFormatParser.directive`.
	 * @param ctx the parse tree
	 */
	exitTrailDirective?: (ctx: TrailDirectiveContext) => void;

	/**
	 * Enter a parse tree produced by the `PeriodDirective`
	 * labeled alternative in `RelativeDateFormatParser.directive`.
	 * @param ctx the parse tree
	 */
	enterPeriodDirective?: (ctx: PeriodDirectiveContext) => void;
	/**
	 * Exit a parse tree produced by the `PeriodDirective`
	 * labeled alternative in `RelativeDateFormatParser.directive`.
	 * @param ctx the parse tree
	 */
	exitPeriodDirective?: (ctx: PeriodDirectiveContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.directive`.
	 * @param ctx the parse tree
	 */
	enterDirective?: (ctx: DirectiveContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.directive`.
	 * @param ctx the parse tree
	 */
	exitDirective?: (ctx: DirectiveContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.relativeExpression`.
	 * @param ctx the parse tree
	 */
	enterRelativeExpression?: (ctx: RelativeExpressionContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.relativeExpression`.
	 * @param ctx the parse tree
	 */
	exitRelativeExpression?: (ctx: RelativeExpressionContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.resolvableExpression`.
	 * @param ctx the parse tree
	 */
	enterResolvableExpression?: (ctx: ResolvableExpressionContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.resolvableExpression`.
	 * @param ctx the parse tree
	 */
	exitResolvableExpression?: (ctx: ResolvableExpressionContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.staticExpression`.
	 * @param ctx the parse tree
	 */
	enterStaticExpression?: (ctx: StaticExpressionContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.staticExpression`.
	 * @param ctx the parse tree
	 */
	exitStaticExpression?: (ctx: StaticExpressionContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.staticPeriod`.
	 * @param ctx the parse tree
	 */
	enterStaticPeriod?: (ctx: StaticPeriodContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.staticPeriod`.
	 * @param ctx the parse tree
	 */
	exitStaticPeriod?: (ctx: StaticPeriodContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.relativePeriod`.
	 * @param ctx the parse tree
	 */
	enterRelativePeriod?: (ctx: RelativePeriodContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.relativePeriod`.
	 * @param ctx the parse tree
	 */
	exitRelativePeriod?: (ctx: RelativePeriodContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.unaryExpr`.
	 * @param ctx the parse tree
	 */
	enterUnaryExpr?: (ctx: UnaryExprContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.unaryExpr`.
	 * @param ctx the parse tree
	 */
	exitUnaryExpr?: (ctx: UnaryExprContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.staticIdentifier`.
	 * @param ctx the parse tree
	 */
	enterStaticIdentifier?: (ctx: StaticIdentifierContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.staticIdentifier`.
	 * @param ctx the parse tree
	 */
	exitStaticIdentifier?: (ctx: StaticIdentifierContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.relativeIdentifier`.
	 * @param ctx the parse tree
	 */
	enterRelativeIdentifier?: (ctx: RelativeIdentifierContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.relativeIdentifier`.
	 * @param ctx the parse tree
	 */
	exitRelativeIdentifier?: (ctx: RelativeIdentifierContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.handler`.
	 * @param ctx the parse tree
	 */
	enterHandler?: (ctx: HandlerContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.handler`.
	 * @param ctx the parse tree
	 */
	exitHandler?: (ctx: HandlerContext) => void;

	/**
	 * Enter a parse tree produced by `RelativeDateFormatParser.timestamp`.
	 * @param ctx the parse tree
	 */
	enterTimestamp?: (ctx: TimestampContext) => void;
	/**
	 * Exit a parse tree produced by `RelativeDateFormatParser.timestamp`.
	 * @param ctx the parse tree
	 */
	exitTimestamp?: (ctx: TimestampContext) => void;
}

